package compat
if (word(2 $loadinfo()) != [pf]) {
	load -pf $word(1 $loadinfo());
	return;
};


#addset's ripped from builtins script written by blackjac.
#xaddset modded a bit thanks to xavier!
alias xaddset (name, type default "str", value) {
         # char and str sanitycheck, no default, int and bool default to 0/off
         switch ($type) {
                 (int) { if (!value) @ value = 0 }
                 (bool) { if (!value) @ value = [off] }
                 (*) { @ type = [str] }
         };
         @symbolctl(create $name);
         @symbolctl(set $name 1 builtin_variable type $type);
         ^set $name $value;
};

#addset (original addset alias from blackjack)
alias addset (name, type, args) {
        if (@name && type) {     
                @ symbolctl(create $name);
                @ symbolctl(set $name 1 builtin_variable type $type);
                if (args) {                                          
                        @ symbolctl(set $name 1 builtin_variable script $args);
                };                                                             
        };        
};

alias delset (name, void) {
        if (@name) {
                @ symbolctl(delete $name builtin_variable);
        };
};



# The following functions were all pulled from the 'builtins' script
# written by David B. Kratter and distributed with EPIC5.
# Thanks BlackJac!
stub alias pfsave -pf save;

alias igmask (pattern, void) {
        return $ignorectl(pattern $pattern);
};

alias igtype (pattern, void) {
        fe ($ignorectl(get $ignorectl(refnum $pattern) levels)) ii {
                push function_return ${ii =~ [+*] ? [^B$rest(1 $ii)^B] : sar(#/##$sar(#^#DONT-#$ii))};
        };
};

alias rigmask (pattern, void) {
        return $ignorectl(rpattern $pattern);
};

alias rigtype (...) {
        return $ignorectl(with_type $*);
};

alias servergroup (refnum default "$serverctl(from_server)", void) {
	if (:group = serverctl(get $refnum group)) {
		return $group;
	};
	return <default>;
};

alias servername (refnum default "$serverctl(from_server)", void) {
	if (:name = serverctl(get $refnum itsname)) {
		return $name;
	};
	return <none>;
};

alias servernick (refnum default "$serverctl(from_server)", void) {
	return $serverctl(get $refnum nickname);
};

alias servernum (refnum default "$serverctl(from_server)", void) {
	if ((:num = serverctl(refnum $refnum)) >= -1) {
		return $num;
	};
	return -1;
};

alias serverourname (refnum default "$serverctl(from_server)", void) {
	if (:ourname = serverctl(get $refnum name)) {
		return $ourname;
	};
	return <none>;
};

alias servertype (refnum default "$serverctl(from_server)", void) {
	return $serverctl(get $refnum protocol);
};

alias servports (refnum default "$serverctl(from_server)", void) {
        return $serverctl(get $refnum port) $serverctl(get $refnum localport);
};

alias winbound (winnum default 0, void) {
	return;
};

alias wincursorline (winnum default 0, void) {
	if ((:cursorline = windowctl(get $windowctl(refnum $winnum) cursor)) >= -1) {
		return $cursorline;
	};
	return -1;
};

alias winlevel (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) window_level);
};

alias winline (linenum, winnum default 0, void) {
	if ((:line = windowctl(get $windowctl(get refnum $winnum) line $linenum)) >= -1) {
		return $line;
	};
	return -1;
};

alias winnam (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) name);
};

alias winnicklist (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) nicklist);
};

alias winnum (winnum default 0, void) {
	if (:num = windowctl(get $windowctl(refnum $winnum) refnum)) {
		return $num;
	};
	return -1;
};

alias winquery (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) query);
};

alias winrefs (void) {
	return $windowctl(refnums);
};

alias winscreen (winnum default 0, void) {
	if ((:screen = windowctl(get $windowctl(refnum $winnum) screen)) >= -1) {
		return $screen;
	};
	return -1;
};

alias winscrollbacksize (winnum default 0, void) {
	if ((:scrollbacksize = windowctl(get $windowctl(refnum $winnum) display_buffer_size)) >= -1) {
		return $scrollbacksize;
	};
	return -1;
};

alias winserv (winnum default 0, void) {
	if ((:serv = windowctl(get $windowctl(refnum $winnum) server)) >= -2) {
		return $serv;
	};
	return -1;
};

alias myservers (arg, void) {
        fe ($serverctl(omatch *)) mm {
                if (serverctl(get $mm connected)) {
                        push :servers $mm;
                };
        };
        fe ($servers) nn {
                push function_return ${@arg ? nn : servername($nn)};
        };
                
};

alias notifywindows (void) {
        fe ($windowctl(refnums)) nn {
                if (windowctl(get $nn notified)) {
                        push function_return $nn;
                };
        };
};

alias lastserver (void) {
        return $serverctl(last_server);
};

alias winsize (winnum default 0, void) {
	return $windowctl(get $windowctl(refnum $winnum) display_size);
};

alias winstatsize (winnum default 0, void) {
	if ((:statsize = windowctl(get $windowctl(refnum $winnum) double)) > -1) {
		return ${statsize + 1};
	};
	return -1;
};

alias winvisible (winnum default 0, void) {
	if ((:visible = windowctl(get $windowctl(refnum $winnum) visible)) >= -1) {
		return $visible;
	};
	return -1;
};

# FULL_STATUS_LINE

addset full_status_line bool {
	if ([$0] == [on]) {
		^set status_format $before(-1  $status_format);
		^set status_format1 $before(-1  $status_format1);
		^set status_format2 $before(-1  $status_format2);
	} else {
		^set status_format $status_format;
		^set status_format1 $status_format1;
		^set status_format2 $status_format2;
	};
};

set full_status_line on;

# REVERSE_STATUS_LINE

addset reverse_status_line bool {
	if ([$0] == [on]) {
		^set status_format $after(1  $status_format);
		^set status_format1 $after(1  $status_format1);
		^set status_format2 $after(1  $status_format2);
	} else {
		^set status_format $status_format;
		^set status_format1 $status_format1;
		^set status_format2 $status_format2;
	};
};

set reverse_status_line on;

#misc aliases/to go with functs that common people use.

alias whowas (nick, number default "$num_of_whowas", void) {
        //whowas $nick $number;
};
addset auto_whowas bool {
        if ([$0] == [on]) {
                ^on #-401 1 "*" {
                        whowas $1;
                };
        } else {
                ^on #-401 1 -"*";
        };
};

^on #-kick 1 '$$servernick() *' {
        if (getset(auto_rejoin) == [on]) {
                if (:delay = getset(auto_rejoin_delay)) {
                        timer -w $winnum() $delay join $2;
                } else {
                        defer join $2;
                };
        };
};

addset dcc_timeout int;

^on #-timer 1 "*" {
        if (:timeout == getset(dcc_timeout)) {
                fe ($dccctl(refnums)) dd {
                        if (time() - word(0 $dccctl(get $dd lasttime)) >= timeout) {
                                @ :nick = dccctl(get $dd user);
                                @ :type = dccctl(get $dd type);
                                shook dcc_lost $nick $type $urlencode($dccctl(get $dd description)) IDLE TIME EXCEEDED;
                                dcc close $type $nick;
                        };
                };
        };
};

addset verbose_ctcp bool;

^on ?ctcp "*" {
        return ${getset(verbose_ctcp) == [on] ? 0 : 1};
};

#nasty hack at my usage of making an auto-reconnect //zak
^on #-server_lost 18 "*" {
        if (getset(auto_reconnect) == [on]) {
                if (:delay = getset(auto_reconnect_delay)) {
                        timer -w $winnum() $delay server +;
                } else {
                        defer server +;
                };
        };        
};

#things below are just various things taken from the epic5/scripts source dir
#to make this script compatable with epic5 without needing to use the builtins
#or too many nonessential aliases/hooks/crap. and some actual improvements.

#done by hop/taken from epic5/scripts source.
addset hold_mode bool {
        fe ($winrefs()) x {
                window $x hold_mode $0;
        };
};
set hold_mode off;

addset hold_interval int {
        fe ($winrefs()) x {
                window $x hold_interval $0;
        };
};
set hold_interval 10;

on #^window_create -125 * {
        window $1 hold_mode $getset(hold_mode);
        window $1 hold_interval $getset(hold_interval);
};

#	Copyright (c) 2005 David B. Kratter (BlackJac@EFNet)
#	Commands:
#		/history [<indexnum>]
#			Returns a list of all commands in the history buffer, or
#			all commands up to <indexnum>.
#		/!<indexnum|pattern>
#			Retrieves history buffer entries and outputs them to the
#			input line. Use /!<indexnum> to retrieve <indexnum> or
#			/!<pattern> to retrieve the most recent entry matching
#			<pattern>.
#
alias history (index, void) {
	xecho -b -c Command History:;
	if (index > (:numitems = numitems(array.history)) || !index) {
		@ index = numitems;
	};
	if (index > 0) {
		fe ($jot(0 ${index - 1} 1)) hh {
			@ :item = getitem(array.history $hh);
			xecho -c $hh${history_timestamp == [on] ? [  \[$word(3 $stime($word(0 $item)))\]  ] : [\: ]}$restw(1 $item);
		};
	};
};

alias history.add (...) {
	if (@) {
		if (history_remove_dupes == [on]) {
			fe ($getmatches(array.history % $*)) hh {
				@ delitem(array.history $hh);
			};
		};
		if (numitems(array.history) == history) {
			@ delitem(array.history 0);
		};
		@ setitem(array.history $numitems(array.history) $time() $*);
		@ history.index = [];
	};
};

alias history.erase (void) {
	@ history.index = [];
	parsekey erase_line;
};

alias history.get (direction, void) {
	if (direction == 1) {
		if (@L && @history.index == 0) {
			history.add $L;
		};
		if ((history.index == (:numitems = numitems(array.history) - 1) || @history.index == 0)) {
			if (history_circleq == [on]) {
				history.show 0;
			} else {
				history.erase;
			};
		} else if (history.index < numitems && @history.index) {
			history.show ${history.index + 1};
		};
	} else if (direction == -1) {
		if (@L && @history.index == 0) {
			history.add $L;
			@ history.index = numitems(array.history) - 1;
		};
		if ((history.index == 0 && history_circleq == [on]) || @history.index == 0) {
			history.show ${numitems(array.history) - 1};
		} else if (history.index > 0) {
			history.show ${history.index - 1};
		};
	};
};

alias history.shove (void) {
	history.add $L;
	parsekey erase_line;
};

alias history.show (index, void) {
	if (@index) {
		@ history.index = index;
		parsekey erase_line;
		xtype -l $restw(1 $getitem(array.history $history.index));
	};
};

alias historyctl (action, ...) {
	switch ($action) {
		(add) {
			if (history) {
				history.add $*;
				return 1;
			};
			return 0;
		};
		(delete) {
			@ delitem(array.history $0);
		};
		(get) {
			return $restw(1 $getitem(array.history $0));
		};
		(index) {
			if (strlen($getitem(array.history $0))) {
				@ history.index = *0;
				return 1;
			};
			return 0;
		};
		(read) {
			if ((:fd = open(${*0 ? *0 : history_save_file} R)) > -1) {
				while (:line = read($fd)) {
					if (numitems(array.history) == history) {
						@ delitem(array.history 0);
					};
					@ setitem(array.history $numitems(array.history) $line);
				};
				@ close($fd);
				return $fd;
			};
		};
		(reset) {
			@ history.index = [];
			@ delarray(array.history);
		};
		(save) {
			if ((:fd = open(${*0 ? *0 : history_save_file} W)) > -1) {
				fe ($jot(0 ${numitems(array.history) - 1} 1)) hh {
					@ write($fd $getitem(array.history $hh));
				};
				@ close($fd);
				return $fd;
			};
		};
		(set) {
			^set history $0;
			return 1;
		};
	};
};

alias sendline (...) {
	if (@) {
		history.add $*;
		//sendline $*;
	};
};

@ bindctl(function BACKWARD_HISTORY create "history.get -1");

@ bindctl(function ERASE_HISTORY create history.erase);

@ bindctl(function FORWARD_HISTORY create "history.get 1");

@ bindctl(function SHOVE_TO_HISTORY create history.shove);

fe (N [OB [[B) hh {
	@ bindctl(sequence ^$hh set forward_history);
};

fe (P [OA [[A) hh {
	@ bindctl(sequence ^$hh set backward_history);
};
                
@ bindctl(sequence ^U set erase_history);

^on ^input "/!*" {
	@ :find = after(! $0);
	if (isnumber($find)) {
		if (:found = getitem(array.history $find)) {
			xtype -l $restw(1 $found)${*1 ? [$1-] : []};
		} else {
			xecho -b -c No such history entry: $find;
		};
	} else if (:found = [$getmatches(array.history % /$find*) $getmatches(array.history % $find*)]) {
		@ :index = rightw(1 $numsort($found));
		if (history_save_position == [on]) {
			@ history.index = index;
		};
		xtype -l $restw(1 $getitem(array.history $index))${*1 ? [ $1-] : []};
	} else {
		xecho -b -c No match;
	};
};

addset history int {
	if (*0 == 0) {
		@ delarray(array.history);
		@ history.index = [];
		^bind ^] nothing;
		^on #input 2 -"*";
		^on #input 2 -"/!*";
	} else if (@) {
		if (numitems(array.history) > history) {
			until (numitems(array.history) == history) {
				@ delitem(array.history 0);
			};
		};
		^bind ^] shove_to_history;
		^on #-input 2 "*" {
			history.add $*;
		};
		^on #-input 2 "/!*" #;
	};
};

set history 150;

addset history_circleq bool;

set history_circleq on;

addset history_persistent bool {
	if (*0 == [on]) {
		^on #-exit 2 "*" {
			@ historyctl(save $history_save_file);
		};
	} else if (@) {
		^on #exit 2 -"*";
	};
};

set history_persistent off;

addset history_save_file str;

set history_save_file ~/.epic_history;

addset history_remove_dupes bool;

set history_remove_dupes off;

addset history_save_position bool;

set history_save_position on;

addset history_timestamp bool;

set history_timestamp on;

if (history_persistent == [on] && fexist($history_save_file) == 1) {
	@ historyctl(read $history_save_file);
};

#newnick stuff from src/epic5/scripts by BlackJac.
#	Copyright (c) 2005 David B. Kratter (BlackJac@EFNet)

alias newnick.mangle (nick, void) {
	@ :length = getset(auto_new_nick_length);
	return ${@nick < length ? nick ## getset(auto_new_nick_char) : right(1 $nick) ## mid(0 ${length - 1} $nick)};
};

^on ^new_nickname "*" {
	if (getset(auto_new_nick) == [on]) {
		if (:nicklist = getset(auto_new_nick_list)) {
			if (!(:nick = word(${findw($2 $nicklist) + 1} $nicklist))) {
				@ :nick = newnick.mangle($2);
			};
		} else {
			@ :nick = newnick.mangle($2);
		};
		xeval -s $0 nick $nick;
	} else {
		input "Nickname: " {
			nick $0;
		};
	};
};

addset auto_new_nick bool;
set auto_new_nick on;

addset auto_new_nick_char char;
set auto_new_nick_char _;

addset auto_new_nick_length int;
set auto_new_nick_length 9;

addset auto_new_nick_list str;
